const dir = require('node-dir');
const exec = require('../exec')


module.exports = {
	all() {
		return new Promise((resolve, reject) => {
			var contens = ''
			dir.readFiles('/usr/share/menu',
				(err, content, next) => {
					if (err) {
						return reject(err)
					}
					contens += content
					next()
				},
				async (err, files) => {
					if (err) {
						return reject(err)
					}
					let cast2type = (t) => {try {return JSON.parse(t)} catch(e){return t}}
					let apps = contens.replace(/\\\n/g, '').replace(/[\t ]+/g, ' ').replace(/.*\): */g, '').split('\n').filter(app => app)
					apps = apps.map(app => Object.fromEntries(Array.from(app.matchAll(/(\S+)="([^"]*)"/g), match => [match[1], cast2type(match[2])])))
					let app = apps.find(app => app.title == this.active)
					if (app) {
						app.active = true
						app.running = (await this.$root.services?.status('appstarter'))?.running
					}
					resolve(apps)
				}
			)
		})
	},

	get app() {
		return (async () => {
			let apps = await this.all()
			let name = apps.find(app => app.title == this.active)?.title || await this.autostart
			return apps.find(app => app.title == name)
		})()
	},

	get autostart() {
		return (async () => {
			let apps = await this.all()
			let app = apps.find(app => app.title == this._autostart)
			if (!app && this._autostart !== false) {
				app = apps.filter(app => app.autostart).sort((a, b) => b.autostart - a.autostart)?.[0]
			}
			return app?.title
		})()
	},
	set autostart(value) {
		if (this.$root.auth.check()) {
			this._autostart = value
		}
	},

	async start(name) {
		this.active = name
		return await exec.cmd(`systemctl restart appstarter`, this.$socket)
	},

	async restart() {
		return await exec.cmd(`systemctl restart appstarter`, this.$socket)
	},

	async stop() {
		delete this.active
		return await exec.cmd(`systemctl stop appstarter`, this.$socket)
	}
}
